unit Unit8;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Buttons, StdCtrls, Gauges, MMSystem;

type
  TForm1 = class(TForm)
    Imgs: TImage;
    Timer1: TTimer;
    Imp: TImage;
    Gvrm: TGauge;
    Gbmb: TGauge;
    Gvrd: TGauge;
    Panel1: TPanel;
    Tela: TImage;
    Label3: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Bt1: TImage;
    BtUp: TImage;
    BtDw: TImage;
    Fim: TImage;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Timer1Timer(Sender: TObject);
    procedure Bt1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ImpMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ImpMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ImpMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Bt1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FimMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    procedure Toca(Nome: string);
    procedure TransCriar;
    procedure MontarMapa;
    procedure SorteiaBots;
  public
  end;

var
  Form1: TForm1;

implementation
{$R *.DFM}

const
  Px: integer = 9;
  Py: integer = 8;
  Bx: integer = 0;
  By: integer = 0;
  Bomba: integer = 0;
  Tvrm: integer = 0;
  Tvrd: integer = 0;
  Partidas: integer = 0;
  Vitorias: integer = 0;

  Mapa: array [0..21,0..31] of byte = (
             (9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9),
             (9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,9),
             (9,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,1,0,1,0,0,0,0,0,0,0,0,9),
             (9,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,9),
             (9,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,9),
             (9,0,0,0,0,0,1,0,0,0,0,1,1,1,1,0,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,9),
             (9,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,9),
             (9,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9),
             (9,1,1,1,1,1,1,0,0,0,0,1,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,9),
             (9,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,1,0,0,0,1,0,0,0,0,0,0,0,1,0,0,9),
             (9,0,0,1,0,0,1,0,0,0,0,1,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,9),
             (9,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,9),
             (9,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9),
             (9,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,9),
             (9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,9),
             (9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,9),
             (9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,9),
             (9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,9),
             (9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,1,1,1,1,9),
             (9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,1,1,1,1,1,0,0,0,0,0,9),
             (9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,9),
             (9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9));

var
  Bfm: TBitmap;
  Antes: byte;
  Jx: array[0..50] of integer;
  Jy: array[0..50] of integer;
  Jd: array[0..50] of byte;
  Tempo: TDateTime;
  Lx,Ly: integer;
  Lk: byte;

//=== Tocar um som =============================================================
procedure TForm1.Toca(Nome: string);
var
  Som: array[0..79] of char;
begin
  StrPCopy(Som,'fung'+Nome+'.wav');
  sndPlaySound(Som,snd_ASync);
end;


//=== Cria o formulrio transparente ===========================================
procedure TForm1.TransCriar;
var
  MaskMap: TBitmap;
  LinRgn,SpRgn,WinRgn: HRGN;
  Lin,Col,Cor: integer;
  Sl: PByteArray;
  SpEsq,SpDir: integer;
begin
  BorderStyle:= bsNone;
  BorderIcons:= [];
  MaskMap:= TBitmap.Create;
  MaskMap.Width:= Imp.Width;
  MaskMap.Height:= Imp.Height;
  MaskMap.Assign(Imp.Picture.Bitmap);
  MaskMap.Mask(clFuchsia);
  MaskMap.Canvas.CopyMode:= cmDSTINVERT;
  MaskMap.Canvas.Draw(0,0,MaskMap);
  MaskMap.PixelFormat:= pf8Bit;
  MaskMap.Canvas.CopyMode:= cmSRCCOPY;
  Height:= Imp.Height;
  Width:= Imp.width;
  WinRgn:= CreateRectRgn(0,0,0,0);
  for Lin:= 0 to Height-1 do begin
    LinRgn:= CreateRectRgn(0,Lin,0,Lin);
    Sl:= MaskMap.scanline[Lin];
    SpEsq:= 0; SpDir:= 0;
    repeat
      Col:= SpEsq;
      Cor:= Sl[Col];
      repeat
        Col:= Col + 1;
      until (Cor <> Sl[Col]) or (Col >= Width);
      SpDir:= Col - 1;
      if Cor <> 0 then begin
        SpRgn:= CreateRectRgn(SpEsq,Lin,SpDir+1,Lin+1);
        CombineRgn(LinRgn, LinRgn, SpRgn, RGN_OR);
        DeleteObject(SpRgn);
      end;
      SpEsq:= SpDir+1;
    until (SpDir >= Width);
    CombineRgn(WinRgn, WinRgn, LinRgn, RGN_OR);
    DeleteObject(LinRgn);
  end;
  SetWindowRgn(Handle,WinRgn,True);
  MaskMap.Free;
end;


//=== Movimenta o form pela tela ===============================================
procedure TForm1.ImpMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Lx:= X; Ly:= Y; Lk:= 1;
end;

procedure TForm1.ImpMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if Lk = 1 then begin
    if X > Lx then Form1.Left:= Form1.Left + (X - Lx);
    if X < Lx then Form1.Left:= Form1.Left - (Lx - X);
    if Y > Ly then Form1.Top:= Form1.Top + (Y - Ly);
    if Y < Ly then Form1.Top:= Form1.Top - (Ly - Y);
  end;
end;

procedure TForm1.ImpMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Lk:= 0;
end;

//------------------------------------------------------------------------------
procedure TForm1.MontarMapa;
var
  Tl,Tc: integer;
begin
  for Tl:= 0 to 21 do begin
    for Tc:= 0 to 31 do begin
      BitBlt(Bfm.Canvas.Handle,Tc*8,Tl*8,8,8,Imgs.Canvas.Handle,Mapa[Tl,Tc]*8,0,srccopy);
    end;
  end;
end;


//------------------------------------------------------------------------------
procedure TForm1.SorteiaBots;
label
  Vt1;
var
  Tm,Tn: integer;
  Tp,Tz: byte;
begin
  for Tm:= 0 to 21 do for Tn:= 0 to 31 do
  if (Mapa[Tm,Tn] = 3) or (Mapa[Tm,Tn] = 4) then Mapa[Tm,Tn]:= 0;
  Mapa[Py,Px]:= 2;
  Tp:= 0; Tz:= 3; Tvrm:= 0; Tvrd:= 0;
  for Tm:= 0 to 50 do begin
    Jx[Tm]:= 0; Jy[Tm]:= 0;
    //Sortei se  para criar um fung
    if random(10) > 6 then begin
    Vt1:
      Jx[Tp]:= random(30)+1;
      Jy[Tp]:= random(20)+1;
      if Mapa[Jy[Tp],Jx[Tp]] <> 0 then goto Vt1;
      Mapa[Jy[Tp],Jx[Tp]]:= Tz;
      if Tz = 3 then inc(Tvrm);
      if Tz = 4 then inc(Tvrd);
      inc(Tz); if Tz = 5 then Tz:= 3;
      Jd[Tp]:= random(3)+1;
      inc(Tp);
    end;
  end;
  Gvrm.MaxValue:= Tvrm + Tvrd;
  Gvrm.Progress:= Tvrm;
  Gvrd.MaxValue:= Tvrm + Tvrd;
  Gvrd.Progress:= Tvrd;
end;


//******************************************************************************
//*** Inicializa o jogo ********************************************************
procedure TForm1.FormCreate(Sender: TObject);
begin
  Randomize; TransCriar;
  Bfm:= TBitmap.Create;
  Bfm.Width:= 256;
  Bfm.Height:= 176;
  Bfm.PixelFormat:= pfDevice;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Bfm.Free;
end;


//=== Processa uma tecla =======================================================
procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  Mapa[Py,Px]:= Antes; if Antes <> 0 then Antes:= 0;
  if Key = Vk_up then begin
    if Mapa[Py-1,Px] = 0 then Py:= Py-1;
  end;
  if Key = Vk_down then begin
    if Mapa[Py+1,Px] = 0 then Py:= Py+1;
  end;
  if Key = Vk_left then begin
    if Mapa[Py,Px-1] = 0 then Px:= Px-1;
  end;
  if Key = Vk_right then begin
    if Mapa[Py,Px+1] = 0 then Px:= Px+1;
  end;
  Antes:= Mapa[Py,Px];
  //Instala um painel de ambiente
  if (Key = Vk_Space) and (Timer1.Enabled) then begin
    Toca('02');
    Antes:= 1;
  end;
  //Instala uma bomba
  if (Key = Vk_Shift) and (Bomba = 0) and (Timer1.Enabled) then begin
    Antes:= 8; Bomba:= 10;
    Bx:= Px; By:= Py;
    Gbmb.Progress:= 10;
  end;
  //Remonta o mapa e mostra ao jogador
  Mapa[Py,Px]:= 2;
  MontarMapa; Tela.Canvas.Draw(0,0,Bfm);
end;


//=== Controle do timer ========================================================
procedure TForm1.Timer1Timer(Sender: TObject);
label
  Vt1;
var
  Tm,Tx,Ty: integer;
begin
  Tm:= 0;
Vt1:
    if Jx[Tm] <> 0 then begin
      //Coodenada de direo do fungo (mover)
      case Jd[Tm] of
        1: begin Ty:= -1; Tx:= 0; end;
        2: begin Ty:= 0; Tx:= +1; end;
        3: begin Ty:= +1; Tx:= 0; end;
        4: begin Ty:= 0; Tx:= -1; end;
      end;
      case Mapa[Jy[Tm]+Ty,Jx[Tm]+Tx] of
        //O que encontrar na prxima casa?
        0: begin  //nada, pode mover
             Mapa[Jy[Tm]+Ty,Jx[Tm]+Tx]:= Mapa[Jy[Tm],Jx[Tm]];
             Mapa[Jy[Tm],Jx[Tm]]:= 0;
             Jy[Tm]:= Jy[Tm]+Ty;
             Jx[Tm]:= Jx[Tm]+Tx;
           end;
        1: begin  //parede muda de direo
             Jd[Tm]:= random(4)+1;
           end;
        2: begin  //jogador Muda de direo
             Jd[Tm]:= random(4)+1;
           end;
        3: begin  //amigo/inimigo vermelho
             if Mapa[Jy[Tm],Jx[Tm]] = 3 then Jd[Tm]:= random(4)+1 else begin
               Toca('05');
               Mapa[Jy[Tm]+Ty,Jx[Tm]+Tx]:= Mapa[Jy[Tm],Jx[Tm]];
               dec(Tvrm); inc(Tvrd);
             end;
           end;
        4: begin  //amigo/inimigo verde
             if Mapa[Jy[Tm],Jx[Tm]] = 4 then Jd[Tm]:= random(4)+1 else begin
               Toca('05');
               Mapa[Jy[Tm]+Ty,Jx[Tm]+Tx]:= Mapa[Jy[Tm],Jx[Tm]];
               dec(Tvrd); inc(Tvrm);
             end;
           end;
        9: begin  //parede muda de direo
             Jd[Tm]:= random(4)+1;
           end;
      end;
    end;
  inc(Tm); if Tm < 51 then goto Vt1;
  //Se existir boma, contagem regressiva
  if Bomba > 0 then begin
    Toca('01');
    dec(Bomba);
    Gbmb.Progress:= Bomba;
    if Bomba = 0 then begin
      Mapa[By,Bx]:= 0; Toca('03');
      if Mapa[By-1,Bx] = 1 then Mapa[By-1,Bx]:= 0;
      if Mapa[By+1,Bx] = 1 then Mapa[By+1,Bx]:= 0;
      if Mapa[By,Bx-1] = 1 then Mapa[By,Bx-1]:= 0;
      if Mapa[By,Bx+1] = 1 then Mapa[By,Bx+1]:= 0;
    end;
  end;
  //Monta o mapa e mostra
  MontarMapa; Tela.Canvas.Draw(0,0,Bfm);
  //Atualiza as barras
  Gvrm.Progress:= Tvrm;
  Gvrd.Progress:= Tvrd;
  //Tempo de jogo
  Label3.Caption:= TimeToStr(Now-Tempo);
  //Terminou a partida?
  if (Tvrd = 0) or (Tvrm = 0) then begin
    Toca('06');
    Timer1.Enabled:= false;
    if Tvrm = 0 then inc(Vitorias);
    Label5.Caption:= IntToStr(Vitorias);
   end;
end;


//=== Processa a tecla de iniciar a partida ====================================
procedure TForm1.Bt1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Toca('04');
  Bt1.Picture.Assign(BtDw.Picture);
  Tela.Picture.Bitmap.PixelFormat:= pfDevice;
end;


procedure TForm1.Bt1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Toca('04');
  Bt1.Picture.Assign(BtUp.Picture);
  SorteiaBots;
  MontarMapa; Tela.Canvas.Draw(0,0,Bfm);
  Antes:= 0;
  Timer1.Enabled:= true;
  Tempo:= Now;
  inc(Partidas); Label4.Caption:= IntToStr(Partidas);
  Label3.Caption:= '00:00:00';
end;


//=== Encerra o jogo ===========================================================
procedure TForm1.FimMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Toca('04');
  Application.Terminate;
end;

end.
